#include "Global.h"
#include "gl_et_al.h";
#include "jttoolkit.h";
//#include "myron.h";


Global *Global::instance;

Global::Global(){


  srand(2); //controlling the random seed.
  instance=this; //making sure we store the global static instance pointer.
  
  // some stuff in opengl that is just not hiphop for me.
  glEnable(GL_LINE_SMOOTH);
  glEnable(GL_BLEND);

  //glHint(GL_LINE_SMOOTH_HINT,GL_NICEST);
  
  mouseIsDown = false;
  breakWait = 1000;
  lastMouseUpTime = 0;
  rotating = false;

  resetAndShuffle();

  grl_logo_easter_egg = false;  

  drips_max = 1000;


  blots.push_back(new JImage("media/blots/00.png"));
  blots.push_back(new JImage("media/blots/01.png"));
  blots.push_back(new JImage("media/blots/02.png"));
  blots.push_back(new JImage("media/blots/03.png"));
  blots.push_back(new JImage("media/blots/04.png"));
  blots.push_back(new JImage("media/blots/05.png"));
  blots.push_back(new JImage("media/blots/06.png"));
  blots.push_back(new JImage("media/blots/07.png"));
  blots.push_back(new JImage("media/blots/08.png"));
  blots.push_back(new JImage("media/blots/09.png"));

  stars.push_back(new JImage("media/stars/00.png"));
  stars.push_back(new JImage("media/stars/01.png"));
  stars.push_back(new JImage("media/stars/02.png"));
  stars.push_back(new JImage("media/stars/03.png"));
  stars.push_back(new JImage("media/stars/04.png"));
  stars.push_back(new JImage("media/stars/05.png"));
  stars.push_back(new JImage("media/stars/06.png"));
  stars.push_back(new JImage("media/stars/07.png"));
  stars.push_back(new JImage("media/stars/08.png"));
  stars.push_back(new JImage("media/stars/09.png"));

  
  fonts.push_back( new JoshFont("media/fonts/script.ttf"));
  fonts.push_back( new JoshFont("media/fonts/stencil.ttf"));


}

void Global::resetAndShuffle(){
    //DELETE ALL PATHS
    int s = paths.size();
    for(int i=0;i<s;i++){
      delete (JPath*)paths.back();
      paths.pop_back();
    }
    
    //choose another style
    rgb.reset();
    rnd.vals.clear();
    //massage nature a bit
    rgb[0].contrast(0.4);
    rgb[1].contrast(0.4);
    rgb[2].contrast(0.4);
    
    killAllDrops();

}


void Global::zapFirstPath(){
    //DELETE first path
    int s = paths.size();
	if (s > 0) {		
		delete (JPath*)paths.back();
		paths.pop_back();
		
		//choose another style
		rgb.reset();
		rnd.vals.clear();
		//massage nature a bit
		rgb[0].contrast(0.4);
		rgb[1].contrast(0.4);
		rgb[2].contrast(0.4);
	}
}


void Global::killAllDrops(){
  //kill all drips
  int s = drips.size();
  for(int i=0;i<s;i++){
    delete (Drip*)drips.back();
    drips.pop_back();
  }
}

Global::~Global(){
  
}

void Global::loop(){ 
  
  glClearColor(0,0,0,0.1);
  

  if(grl_logo_easter_egg){
    //GRL SPINNING LOGO FOR VHS
    glPushMatrix();
    glTranslatef(width()/2,height()/2,0);
    JoshFont *f = getFont();
    glRotatef(ticks(),0,1,0);
    glTranslatef(-100,500,0);
    glTranslatef(0,0,-500);
    for(int i=0;i<400;i++){
      if(i==100)glColor4f(1,1,1,0.7);
      else glColor4f(1,0.9,0,0.02);
      f->drawString("GRL",400,1);
      glTranslatef(0,0,2.5);
    }
    glPopMatrix();
  }

    
  //adding new vertices to the current path
  if(mouseIsDown){
    // check if mouse moved a significant amount
    if (lastMouseY != mouseY() || lastMouseX != mouseX())
		paths.front()->pushPointBack(mouse());
  }

  //rendering the paths
  deque<JPath*>::reverse_iterator it;
  deque<JPath*>::iterator fit;
  
  //draw global outline first
  for(it=paths.rbegin(); it!=paths.rend();it++){
    JPath p((*it)->points);
/*
	if (it != paths.rbegin()) {
	  glTranslatef(width()/2,height()/2,0);
      glRotatef(ticks(),0,1,0);
*/
    p.smooth(4);
    //p.melt(0.5);
    //p.melt(0.5);
    glColor4f(rgb[0].r,rgb[0].g,rgb[0].b,rnd[50]/50.0);
    p.stroke_width = 0.2;
    p.stroke_flare = 0.3;
    if(rnd[67]>0.5)p.stroke_style = 2;
    //p.stroke(0,0);
	p.stroke(3.0);
  }


  //then draw the individual contours with local outlines
  for(it=paths.rbegin();it!=paths.rend();it++){
    JPath p((*it)->points);
    p.smooth(4);

    glColor4f(rgb[1].r,rgb[1].g,rgb[1].b,1);
    p.stroke_width = 0.4;
    p.stroke_flare = 0.4;
    p.eatPointsFromBothEnds(8);
    
    if(rnd[1]>0.5){
      p.stroke_style = 2;
      //p.stroke(0,0);
	  p.stroke(3.0);
	} else p.extrudePsychedelic();
    
    glColor4f(1,0.78,0.9,1);
    p+=JPoint(9,9,0);
    p.stroke_width = 0.3;
    p.stroke_flare = 0.3;
    glColor4f(rgb[2].r,rgb[2].g,rgb[2].b,0.8);
    
    if(rnd[0]>0.5){
      p.stroke_style = 2;//change to the worm
      //p.stroke(0,0);
	  p.stroke(3.0);
    }else p.extrudePsychedelic();
  }


  float white_probability = 0.95;

/*
  //render fluff on own layer
  int i=0;
  for(fit=paths.begin();fit!=paths.end();fit++){
    float s = 2;
    ColorRGB c1 = getScreenPixel(
				(**fit).points.back()->x,
				(**fit).points.back()->y
				);
    ColorRGB c2 = getScreenPixel(
				 (**fit).points.front()->x,
				(**fit).points.front()->y
				);
    glPushMatrix();
    (**fit).points.back()->glTranslate();
    glScalef(rnd[i*100+0]*s,rnd[i*100+0]*s,rnd[i*100+0]*s);
    glTranslatef(-128,-128,0);
    if(i!=0){
      if(rnd[i*100+12]>white_probability)glColor4f(1,1,white_probability,rnd[i*100+2]);
      else glColor4f(c1.red(),c1.green(),c1.blue(),rnd[i*100+2]);
      blots[rnd[i*100+5]*(blots.size()-1)]->draw();
      if(rnd[i*100+10]>white_probability)glColor4f(1,1,white_probability,rnd[i*100+9]);
      else glColor4f(c1.red(),c1.green(),c1.blue(),rnd[i*100+9]);
      stars[rnd[i*100+5]*(stars.size()-1)]->draw();
    }
    glPopMatrix();
    
    glPushMatrix();
    (**fit).points.front()->glTranslate();
    glScalef(rnd[i*100+1]*s,rnd[i*100+1]*s,rnd[i*100+1]*s);
    glTranslatef(-128,-128,0);
    if(rnd[i*100+13]>white_probability)glColor4f(1,1,white_probability,rnd[i*100+3]);
    else glColor4f(c2.red(),c2.green(),c2.blue(),rnd[i*100+3]);
    blots[rnd[i*100+6]*(blots.size()-1)]->draw();
    if(rnd[i*100+11]>white_probability)glColor4f(1,1,white_probability,rnd[i*100+10]);
    else glColor4f(c2.red(),c2.green(),c2.blue(),rnd[i*100+10]);
    stars[rnd[i*100+5]*(stars.size()-1)]->draw();
    glPopMatrix();
    i++;
	
	
  }
*/


  //babysitting those drips
  deque<Drip*>::iterator drip_it;
  for(drip_it = drips.begin() ; drip_it != drips.end() ; drip_it++ ){
    (*drip_it)->step();
  }
  
  if(!grl_logo_easter_egg){
    for(drip_it = drips.begin() ; drip_it != drips.end() ; drip_it++ ){
      (*drip_it)->draw();
    }
  }
  
  
  //make a new drip?
  int safety_counter = 0;
  if(randomFloat()>0.1 && drips.size()<drips_max){
  do_over:
    float x = randomFloat()*width();
    float y = randomFloat()*height();
    float z = 0;
    ColorRGB c = getScreenPixel(x,y);


	//old - changed this
    //if( !mouseIsDown && (c.red()!=0 || c.green()!=0 || c.blue()!=0 )){//make sure not to drip the background.

    if (c.red()!=0 || c.green()!=0 || c.blue()!=0 ){//make sure not to drip the background.
      drips.push_back(new Drip(x,y,z));
    }else{
      safety_counter++;
      if(safety_counter < 100 )goto do_over;
    }


  }


  
  /*
  // THE RENDERING STATION
  // UNCOMMENT THIS SHIZ
  char s[256];
  sprintf(s,"render/%05i.png",ticks());
  saveScreen(s);
  */
  
}


void Global::keyDown(int k,int special){
  if(k==' ') {
    resetAndShuffle();
  }
  else if(k=='l') 
  {
    grl_logo_easter_egg = !grl_logo_easter_egg;
  } 
  else if (k=='z')
  {
	zapFirstPath();
  } 
  else if (k == 'x') rotating = true; 
   
  else if (k == 'c') 
  {
	paths.back()->useInnerFill = false;
	paths.back()->useOutline = true;
  }
  else if (k == 'v') 
  {
	paths.back()->useInnerFill = true;
	paths.back()->useOutline = false;
  } else if (k=='a') killAllDrops();
  
}

void Global::keyUp(int k,int special){
 if (k == 'x') rotating = false;
}

void Global::mouseDown(){
  if (!rotating)
  {
	paths.push_front(new JPath());//start a new path
  } else {
  

	float deltaMY = (lastMouseY - (float) mouseY()) / (float) width(); 
	float deltaMX = (lastMouseX - (float) mouseX()) / (float) width(); 
  
	if (deltaMY > 10) lastMouseY = mouseY();
	if (deltaMX > 10) lastMouseX = mouseX();
	
  
	int deltaMTime = ticks() - lastMouseUpTime;
	
	cout << "deltaMTime: " << deltaMTime << endl;
  }
  
  mouseIsDown = true;
  
  
  
  
}


void Global::mouseUp(){
  mouseIsDown = false;  
  lastMouseUpTime = ticks();
  //cout << "lastMouseUpTime: ";
  //cout << lastMouseUpTime << endl;
}

