#include "JChain.h"
#include "jttoolkit.h"
#include "Global.h"

JChain::JChain(deque<JMass*> m,float v){
  strength=v;
  src=new JPoint();
  dst= new JPoint();
  deque<JMass*>::iterator it;
  for(it=m.begin();it!=m.end();it++){
    masses.push_back(*it);
  }
}

JChain::JChain(float v){
  strength=v;
  src=new JPoint();
  dst= new JPoint();
}

JChain::~JChain(){
  delete src;
  delete dst;
}

void JChain::step(){

  for(int i=0;i<masses.size();i++){
    if(i==0)masses[i]->springTo(*src,strength);       
    else masses[i]->springTo(*masses[i-1],strength);  
  }
  for(int i=masses.size()-1;i>=0;i--){
    if(i==masses.size()-1)masses[i]->springTo(*dst,strength);       
    else masses[i]->springTo(*masses[i+1],strength);  
  }
  
}

void JChain::draw(){
  glBegin(GL_LINE_STRIP);
  src->glVertex();
  for(int i=0;i<masses.size();i++){
    masses[i]->glVertex();
  }
  dst->glVertex();
  glEnd();
}

