#include "JImageSequence.h"
#include "jttoolkit.h"
#include "Global.h"

void JImageSequence::load(char *filestr_, int begin_, int end){
  loopCount = 0;
  filestr = new char[512];
  sprintf(filestr,"%s",filestr_);
  begin=begin_;
  //load frame 1.
  char filename[512];
  sprintf(filename,filestr,begin);
  frames.push_back(new JImage(filename));
  
  max = end-begin;
  counter = 0;
  frameNum = begin;
}

JImageSequence::JImageSequence(char *filestr_, int begin, int end){
  load(filestr_,begin,end);
}

JImageSequence::~JImageSequence(){
  delete filestr;
  for(int i=0;i<frames.size();i++){
    delete frames[i];
  }
}

void JImageSequence::step(){
  counter++;
  if(counter==max){
    counter=0;
    loopCount++;
  }
  frameNum = begin+counter;
}

void JImageSequence::stepBack(){
  counter--;
  if(counter<0)counter = max-1;
  frameNum = begin+counter;
}



void JImageSequence::draw(){
  
  while(frames.size()-1<counter){
    //load frame 
    char filename[512];
    sprintf(filename,filestr,begin+frames.size());
    frames.push_back(new JImage(filename));
  }
  
  frames[counter]->drawList();
}

