#ifndef _JTrack_H_
#define _JTrack_H_


//conveniences
#include <deque>
//#include <iostream>
#include "JPoint.h"
//#include "JMass.h"


using namespace std;

/**
   a convenience class to handle a time based changing point in time. For example, a shake track.
   @author jtnimoy
*/
class JTrack{
 public:
  deque<JPoint*> points;  ///< a list of internal points.
  int counter; ///< a time counter.
  int pointcount; ///< how many points per frame?
  int frames; ///< how many time frames in this track?
  int wrap_count; ///< how many times has the sequence wrapped so far?

  /**
     pass a text file on the hard disk containing whitespace-seperated
     human readable tokens. specify how many frames and point count
     per frame.
  */
  JTrack(char *s,int points,int frames); 
  ~JTrack();
  void step(); ///< step in time. wrap self automagically.
  JPoint* operator[](int i); ///< overloaded indexer returning one of multiple jpoints in the current frame.
};


#endif

